% Programma per la risoluzione numerica di
% sistemi di equazioni differenziali 2D con diversi metodi
% Corso MNED 2011/2012 - Studente bla...
h=0.05;
testfunction=1;

switch testfunction
    case 1
        funz='[3*y(1)+2*y(2); 4*y(1)+y(2)]';
        f=inline(funz,'t','y');
        solution=inline('[(exp(5*t)-exp(-t))/3 (exp(5*t)+2*exp(-t))/3]');
        y0=[0 1];
        DT=[0 1];
    case 2
end

H=length(h); % Numero passi temporali
M=4; % Numero metodi sviluppati
laball=cell(M+2,1);
laball2=cell(M+1,1);
hmeth=zeros(M+2,1);
hmethp=zeros(M+2,1);
herr=zeros(M+1,1);

col='brgcmy';

mymethods=0;
methods=0;

% ode23
methods=methods+1;
methlab='ode23';
laball{methods+1}=methlab;
laball2{methods}=methlab;
laball{1}='Soluzione vera';

tic
[t y]=ode23(f,DT,y0);
tim=toc;
fprintf('Metodo %s: N=%i - Tempo=%f\n',methlab,length(t),tim)

ytrue=solution(t);

figure(1); clf;
set(gcf,'Name','Soluzioni')
subplot(2,2,1)
plot(t,ytrue(:,1),'--k','LineWidth',2);
hold on
subplot(2,2,3)
hmeth(1)=plot(t,ytrue(:,2),'--k','LineWidth',2);
hold on
subplot(2,2,2)
plot(t,y(:,1)-ytrue(:,1),col(methods));
hold on
subplot(2,2,4)
herr(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods));
hold on
maxerr=max(abs(y-ytrue));
fprintf('L-infty error: %f -%f -- ',maxerr)

subplot(2,2,1)
plot(t,y(:,1),col(methods));
hold on
subplot(2,2,3)
hmeth(methods+1)=plot(t,y(:,2),col(methods));
hold on
fprintf('CPU time: %f\n',tim)

figure(2)
set(gcf,'Name','Phase plane plot')
clf

hmethp(1)=plot(ytrue(:,1),ytrue(:,2),'k','LineWidth',2);
hold on

hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));

% Metodo di Eulero
methods=methods+1;
methlab='Eulero';
laball{methods+1}=methlab;
laball2{methods}=methlab;

tic
[t y]=myeuler(f,DT,y0,h);
tim=toc;
fprintf('Metodo %s: N=%i - Tempo=%f\n',methlab,length(t),tim)

ytrue=solution(t);

figure(1); 
subplot(2,2,2)
plot(t,y(:,1)-ytrue(:,1),col(methods));
subplot(2,2,4)
herr(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods));
maxerr=max(abs(y-ytrue));
fprintf('L-infty error: %f -%f -- ',maxerr)

subplot(2,2,1)
plot(t,y(:,1),col(methods));
subplot(2,2,3)
hmeth(methods+1)=plot(t,y(:,2),col(methods));
fprintf('CPU time: %f\n',tim)

figure(2)
hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));

% Metodo di Runge-Kutta 2
methods=methods+1;
methlab='RK2';
laball{methods+1}=methlab;
laball2{methods}=methlab;

tic
[t y]=myrk2(f,DT,y0,h);
tim=toc;
fprintf('Metodo %s: N=%i - Tempo=%f\n',methlab,length(t),tim)

ytrue=solution(t);

figure(1); 
subplot(2,2,2)
plot(t,y(:,1)-ytrue(:,1),col(methods));
subplot(2,2,4)
herr(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods));
maxerr=max(abs(y-ytrue));
fprintf('L-infty error: %f -%f -- ',maxerr)

subplot(2,2,1)
plot(t,y(:,1),col(methods));
subplot(2,2,3)
hmeth(methods+1)=plot(t,y(:,2),col(methods));
fprintf('CPU time: %f\n',tim)

figure(2)
hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));

% Metodo di Runge-Kutta 4
methods=methods+1;
methlab='RK4';
laball{methods+1}=methlab;
laball2{methods}=methlab;

tic
[t y]=myrk4(f,DT,y0,h);
tim=toc;
fprintf('Metodo %s: N=%i - Tempo=%f\n',methlab,length(t),tim)

ytrue=solution(t);

figure(1); 
subplot(2,2,2)
plot(t,y(:,1)-ytrue(:,1),col(methods));
subplot(2,2,4)
herr(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods));
maxerr=max(abs(y-ytrue));
fprintf('L-infty error: %f -%f -- ',maxerr)

subplot(2,2,1)
plot(t,y(:,1),col(methods));
subplot(2,2,3)
hmeth(methods+1)=plot(t,y(:,2),col(methods));
fprintf('CPU time: %f\n',tim)

figure(2)
hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));

% Metodo di Eulero implicito
methods=methods+1;
methlab='Eulero impl.';
laball{methods+1}=methlab;
laball2{methods}=methlab;

tic
[t y]=myeulerback(f,DT,y0,h);
tim=toc;
fprintf('Metodo %s: N=%i - Tempo=%f\n',methlab,length(t),tim)

ytrue=solution(t);

figure(1); 
subplot(2,2,2)
plot(t,y(:,1)-ytrue(:,1),col(methods));
subplot(2,2,4)
herr(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods));
maxerr=max(abs(y-ytrue));
fprintf('L-infty error: %f -%f -- ',maxerr)

subplot(2,2,1)
plot(t,y(:,1),col(methods));
subplot(2,2,3)
hmeth(methods+1)=plot(t,y(:,2),col(methods));
fprintf('CPU time: %f\n',tim)

figure(2)
hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));

% Fine metodi

figure(1)
subplot(2,2,1)
title('Soluzione')
ylabel('y_1')
subplot(2,2,2)
ylabel('Errore_1')
title('Errore')
subplot(2,2,3)
ylabel('y_2')
xlabel('t')
legend(hmeth,laball,'Location','Best')
subplot(2,2,4)
ylabel('Errore_2')
xlabel('t')
legend(herr,laball2,'Location','Best')

figure(2)
title('Spazio delle fasi')
xlabel('y_1')
ylabel('y_2')
legend(hmethp,laball,'Location','Best')
